(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@microfocus-lre/ui-shared-components', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (global = global || self, factory((global['microfocus-lre'] = global['microfocus-lre'] || {}, global['microfocus-lre']['ui-shared-components'] = {}), global.ng.core, global.ng.forms, global.ng.common));
}(this, (function (exports, core, forms, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ui-shared-form-control/ui-shared-form-control.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // import {LocaleService} from '@locale/services/locale.service';
    var UiSharedFormControlComponent = /** @class */ (function () {
        function UiSharedFormControlComponent() {
            this.errorMessages = { invalidChars: 'There are some invalid characters',
                required: 'The field shoun\'t be empty',
                maxlength: 'The field text length is to long' };
            this.isRequired = false;
            this.controlType = 'text';
            this.showWarning = false;
            this.labelSize = '120px';
        }
        /**
         * @return {?}
         */
        UiSharedFormControlComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.inputCtrl) {
                /** @type {?} */
                var ctrl_1 = this.inputCtrl;
                this.inputCtrl.valueChanges
                    .subscribe((/**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var errors = __assign({}, _this.controlErrorMessages, _this.errorMessages);
                    if (ctrl_1.invalid && Object.keys(ctrl_1.errors).length > 0) {
                        /** @type {?} */
                        var ctrlErrors_1 = Object.keys(ctrl_1.errors);
                        /** @type {?} */
                        var foundErrors = Object.keys(errors).filter((/**
                         * @param {?} errKey
                         * @return {?}
                         */
                        function (errKey) {
                            return ctrlErrors_1.includes(errKey);
                        }));
                        if (foundErrors.length > 0) {
                            _this.controlErrorMessage = errors[foundErrors[0]];
                        }
                    }
                }));
            }
        };
        UiSharedFormControlComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-shared-form-control',
                        template: "<div class=\"form-group form-group-validation row validate form-component\" [formGroup]=\"parentForm\"\r\n     [ngStyle]=\"{'grid-template-columns': labelSize  + ' 1fr ',\r\n     '-ms-grid-columns': labelSize  + ' 1fr '}\"\r\n     [class.has-error]=\"inputCtrl && inputCtrl.invalid && inputCtrl.touched\">\r\n  <label [for]=\"controlName\" [title]=\"controlLabel\"\r\n         class=\"form-label control-label\">\r\n    <span class=\"text-ellipsis\">{{controlLabel}}</span>\r\n    <ng-content select=\"[label]\" class=\"form-control\"></ng-content>\r\n    <span *ngIf=\"isRequired\" class=\"form-control-validation\">&nbsp;*</span>\r\n  </label>\r\n  <div class=\"form-field\">\r\n    <ng-content  class=\"form-control\"></ng-content>\r\n    <input *ngIf=\"controlType != 'other'\" [type]=\"controlType\" class=\"form-control text-ellipsis\" [formControlName]=\"controlName\"  [id]=\"controlName\"\r\n           aria-describedby=\"control-error-help-block\" [ngClass]=\"{'show-warning': showWarning}\">\r\n    <div id=\"control-error-help-block\" class=\"help-block\" *ngIf=\"controlErrorMessage !== ''\"\r\n         [title]=\"controlErrorMessage\"\r\n         [ngClass]=\"{'visible': inputCtrl && inputCtrl.invalid && inputCtrl.touched}\">\r\n      <div class=\"error-icon icon-small-error\"></div>\r\n      <div>{{controlErrorMessage}}</div>\r\n    </div>\r\n    <div id=\"control-warning-help-block\" class=\"help-block no-top-margin\"\r\n         [title]=\"controlWarningMessage\"\r\n         [ngClass]=\"{'visible': showWarning && !(inputCtrl && inputCtrl.invalid && inputCtrl.touched)}\">\r\n      <div class=\"icon-warning\"></div>\r\n      <div>{{controlWarningMessage}}</div>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                        styles: [".error-icon.visible,.icon-warning.visible{display:block;width:16px;margin-right:16px}.error-icon{color:#e5004c}.icon-warning{color:#ffb000}.form-component{display:grid;display:-ms-grid}.form-component label{grid-column:1;-ms-grid-column:1;padding-top:6px;padding-right:6px;display:flex;height:54px}.form-component label span:first-child{max-width:95%}.form-component label span:nth-child(2){max-width:5%;margin-left:-3px;margin-top:-2px;color:#e4254c}.form-component .form-field{grid-column:2;-ms-grid-column:2;font-size:16px;color:#000;font-family:Metric}.form-group.form-group-validation.row.validate{margin:0;height:54px}.form-group.form-group-validation.row.validate .has-error input[type=text]:focus:hover,.form-group.form-group-validation.row.validate.has-error input[type=text]:focus{border-color:#e5004c}.form-group.form-group-validation.row.validate input:focus.show-warning{border-color:#ffb000}.form-group.form-group-validation.row.validate div.help-block{margin-top:6px;margin-bottom:0;opacity:0;font-size:14px;line-height:1;font-weight:400;visibility:hidden;display:flex;height:0;transform:translateY(-10px);transition:120ms ease-in}.form-group.form-group-validation.row.validate div.help-block .error-icon,.form-group.form-group-validation.row.validate div.help-block .icon-warning{margin-right:4px;vertical-align:baseline;line-height:1;display:inline-block;font-style:normal}.form-group.form-group-validation.row.validate div.help-block.visible{opacity:1;height:100%;visibility:visible;transform:translateX(0);transition:120ms ease-in}.form-group.form-group-validation.row.validate div.help-block.visible.no-top-margin{margin-top:0}.text-ellipsis{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.form-label{font-family:Metric,\"Helvetica Neue\",Helvetica,Arial,sans-serif;color:rgba(0,0,0,.56);font-size:16px;font-weight:400;opacity:1;max-width:100%;margin-bottom:5px}input[type=color],input[type=date],input[type=datetime-local],input[type=datetime],input[type=email],input[type=month],input[type=number],input[type=password],input[type=range],input[type=search],input[type=tel],input[type=text],input[type=time],input[type=url],input[type=week],select.form-control,textarea,textarea.form-control{height:32px;width:100%;line-height:16px;font-size:16px;color:#000;background-color:transparent;border:solid rgba(101,102,104,.64);border-radius:0;border-width:0 0 1px;padding:7px 0;box-shadow:none;box-sizing:border-box;margin-bottom:0;text-align:left;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}input[type=color]:focus,input[type=date]:focus,input[type=datetime-local]:focus,input[type=datetime]:focus,input[type=email]:focus,input[type=month]:focus,input[type=number]:focus,input[type=password]:focus,input[type=range]:focus,input[type=search]:focus,input[type=tel]:focus,input[type=text]:focus,input[type=time]:focus,input[type=url]:focus,input[type=week]:focus,select.form-control:focus,textarea.form-control:focus,textarea:focus{border-color:#0073e7;box-shadow:unset;outline:0}"]
                    }] }
        ];
        /** @nocollapse */
        UiSharedFormControlComponent.ctorParameters = function () { return []; };
        UiSharedFormControlComponent.propDecorators = {
            inputCtrl: [{ type: core.Input }],
            parentForm: [{ type: core.Input }],
            controlName: [{ type: core.Input }],
            controlLabel: [{ type: core.Input }],
            controlErrorMessages: [{ type: core.Input }],
            isRequired: [{ type: core.Input }],
            controlType: [{ type: core.Input }],
            showWarning: [{ type: core.Input }],
            controlWarningMessage: [{ type: core.Input }],
            labelSize: [{ type: core.Input }]
        };
        return UiSharedFormControlComponent;
    }());
    if (false) {
        /** @type {?} */
        UiSharedFormControlComponent.prototype.errorMessages;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.inputCtrl;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.parentForm;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlName;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlLabel;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlErrorMessages;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.isRequired;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlType;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.showWarning;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlWarningMessage;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.labelSize;
        /** @type {?} */
        UiSharedFormControlComponent.prototype.controlErrorMessage;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ui-components.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UiComponentsModule = /** @class */ (function () {
        function UiComponentsModule() {
        }
        UiComponentsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [UiSharedFormControlComponent],
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule
                        ],
                        exports: [UiSharedFormControlComponent]
                    },] }
        ];
        return UiComponentsModule;
    }());

    exports.UiComponentsModule = UiComponentsModule;
    exports.UiSharedFormControlComponent = UiSharedFormControlComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=microfocus-lre-ui-shared-components.umd.js.map
