import { OnInit } from '@angular/core';
import { AbstractControl, FormGroup } from '@angular/forms';
export declare class UiSharedFormControlComponent implements OnInit {
    errorMessages: {
        invalidChars: string;
        required: string;
        maxlength: string;
    };
    inputCtrl?: AbstractControl;
    parentForm: FormGroup;
    controlName: string;
    controlLabel: string;
    controlErrorMessages?: object;
    isRequired: boolean;
    controlType: 'text' | 'password' | 'email' | 'number' | 'other';
    showWarning: boolean;
    controlWarningMessage: string;
    labelSize: string;
    controlErrorMessage: string;
    constructor();
    ngOnInit(): void;
}
